/* DYNAMIC LIGHTWEIGHT SC DENSE CODE. Decompressor -- 
A dynamic word-based byte oriented compressor for text files based on 
(s,c)-Dense Code.

Programmed by Antonio Faria
Copyright (C) 2006  Nieves R. Brisaboa, Gonzalo Navarro, Antonio Faria and Jos R. Param
Author's contact: antonio.fari@gmail.com

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/


#include "decompressor.h"



void initializeScapeValues() {
	
	unsigned long value,kk;

	C_NEW =  W[S_value][3]-3;
	C_SWAP =  W[S_value][3] -2;
	C_SCHANGE =  W[S_value][3] -1;
	

//	fprintf(stderr,"\n C_new_pos %ld, c_swap_pos %ld, c_schange_pos %ld", C_NEW,C_SWAP,C_SCHANGE);	
//
//	fprintf(stderr,"\n Svalue --> %ld", S_value);
//	fprintf(stderr,"\n C_new_pos %0x, c_swap_pos %0x, c_schange_pos %0x", C_NEW,C_SWAP,C_SCHANGE);
//	fprintf(stderr,"\n C_new_pos %ld, c_swap_pos %ld, c_schange_pos %ld", C_NEW,C_SWAP,C_SCHANGE);
//	fprintf(stderr,"\nSALE DE  INIT SCAPE VALUES\n");
	}



	#define LINE_UP(x,numBytes) ((x>>(4-numBytes)*8))    //move "4-bytes" bytes to the right
							   						   			  //so we can write "bytes" bytes from &x
	#ifdef LITTLE_ENDIAN
		#define LE_LONG32(x)  (((x&0xff000000)>>24)|((x&0x00ff0000)>>8)|((x&0x0000ff00)<<8)|((x&0x000000ff)<<24))
	#else
		#define LE_LONG32(x) x
	#endif

	
//obtains the bytes of a number and writes they to *code.	
void getBytes(unsigned char *code, unsigned long number, int numBytes) {
	unsigned long tmp;
	int i;
	unsigned char *pt;
	
	tmp = LE_LONG32(number);
	tmp = LINE_UP (tmp,numBytes);
	pt = (unsigned char *)&tmp;
	
	for (i=0;i<numBytes;i++) {
		code[i]= pt[i];				
	}	
}

/*----------------------------------------------------------------
 * Obtains the codeword of a word ranked in "position"
 * returns the codeword and its size by modifing
 * two global scope variables: CODEWORD and K
------------------------------------------------------------------ */
void getCode(register unsigned long position,
						register unsigned long *codeword, register unsigned int *k){

	register unsigned long kk=1; //counts the number of bytes of the codeword to be generated
	register unsigned long code;
	if (position >= S_value) {
	   register unsigned long seguir;
		register unsigned  long i,r;
		register unsigned  long code;
		i=position;
		(code) = (i % S_value);
		seguir 	  = (i / S_value) -1;

		while (seguir >= C_value) {
			r = seguir % C_value;
			seguir = seguir/C_value -1;
			//seguir -=1;
			(code) = (code) + ( (r + S_value)<<(8*kk) ) ;
			kk ++;
		}
		(code) = (code) + ( (seguir + S_value  )<<(8*kk) ) ;
		kk ++;

		*k  = kk;
		*codeword= code;
	}
	else {
		*k  = kk;
		*codeword= code;
	}
}
	
	
	
/*----------------------------------------------------------------
  Useful for debugging purposes
------------------------------------------------------------------ */	
	void printCodigo (unsigned char *cw, int size) {
	int i;
	unsigned char *c;
	c=cw;
	fprintf(stderr,"\n@@PRINTCODIGO codeSize= %d, CODIGO:",size);
	for (i=0;i<size;i++) {fprintf(stderr,"[%d]",*(c++));}
	fprintf(stderr,"... FIN ..." );
	}
	
	void printCodigo3 (unsigned char *cw, int size) {
		int i;
		unsigned char *c;
		c=cw;
		fprintf(stderr,"<" );
		for (i=0;i<size;i++) {fprintf(stderr,"[%d]",*(c++));}
		fprintf(stderr,">" );
	}
	
	void printCodigo2 (unsigned char  *cw, int size) {
		int i;
		unsigned char  *c;
		c=cw;
		for (i=0;i<size;i++) {fprintf(stderr,"[%d]",*(c++));}
	}
	
	void printCodigoPosition(register unsigned long posicion) {
	unsigned long codigo;
	unsigned int i;
	unsigned char CODIGO [6];
	getCode(posicion,&codigo,&i);
	getBytes(CODIGO,codigo,i);
	printCodigo2(CODIGO,i);
	}
		

/*------------------------------------------------------------------
 Initializes data structures
 ---------------------------------------------------------------- */
void initialize (unsigned long tamArq){
	unsigned long i;

	_memMgr = createMemoryManager(); //_memMgr.initialize();

	N=tamArq;
	words  = (t_word *) malloc(N * sizeof(t_word));
	zeroNode = 0;
	
	S_value = Initial_S_value;
	C_value = B_value - S_value;
	
	initializeScapeValues();
}




/*-----------------------------------------------------------------------
 Insert a new element into vocabulary (in the array of words) !!not used now
 ---------------------------------------------------------------------*/
 void insertElement (const unsigned char *aWord, register unsigned long len , register unsigned long position) {

	if (position == N){
		printf("Not enough memory, vocabulary exceeds maximun size !\n");
		exit(1);
	}

	getMemoryBlock(_memMgr,( char **)&(words[position].word),len+1);

	{
	 unsigned char *w,*src;
	 src=(unsigned char*) aWord;

	 w=words[position].word;
	 for (register int i=0;i<=len;i++) {  //copia tambien el '\0'
		 *(w++)=*(src++);
	 }

	}
//	strncpy ((char *) words[position].word, (char *)aWord, len);
//	words[position].word[len]='\0';
	words[position].size=len;

	////fprintf(stderr,"\n PALABRA INSERTADA [%s]",words[position].word);
}


/*------------------------------------------------------------------
 * Performs the full decoding process.
------------------------------------------------------------------ */
void mainDecompressor (char* infile, char* outfile, unsigned long N_val) {

  
  unsigned char *palabra;
  unsigned long codeSize1;
  unsigned char *tmpW;
  register unsigned char abyte;
  BufferRead B;

	int f;
	unsigned char *text,*top, *nextbuf;



// Inicializacin del buffer de lectura
	f = open (infile, O_RDONLY);
	if (f == -1)
		printf("Cannot read file %s",*infile);
	B = bufCreate(MAX_SIZE_OF_WORD+5);    //nmero de "bytes" que hay que dejar al final del buffer siempre, por culpa
													  //de que pudiese venir una nueva palabra"que fuese cortada".
	bufSetFile (B,f);

// Inicializacin del buffer de escritura
	outWriter = createWriter (outfile);

   initialize(N_val); //initializes decompressor for up to N_value words

	//fprintf(stderr, "\n\n\nSTARTING DECOMPRESSION...[%ld]", B->fpos);

{
    /**/unsigned char *pbeg,*pend,*codeStart,*codeStart2;
	unsigned long K,Ktmp; /***/
	
	while (!bufEmpty(B) ) {

		//fprintf(stderr, "\nEntra en while principal");

		bufCurrent (B,(char**)&text,(char**)&top);
		pbeg = text; pend = top;
	    //fprintf(stderr,"\n top = [%ld]",((unsigned long) top) - ((unsigned long)B->data));


		while ( pbeg < pend )   {
			codeStart = pbeg;

			//fprintf(stderr,"\n decodificado=[%ld], bytes [%ld], con zeronodoe = [%ld]",j,pbeg - codeStart +1,zeroNode);
			K=1;
			
			//decoding next codeword
			if ( (*pbeg) >= S_value ) {
				j = (*pbeg) - S_value;
				pbeg++;
				K++;
	
				while ((*pbeg) >= S_value) {
	
					j = j * C_value + ((*pbeg) - S_value);
					pbeg++;
					K++;
				}
	
				j = j * S_value + (*pbeg);
				j += W[S_value][K-2];
	
			}
			else {
				j = (*pbeg);
			}
			//end decoding
			

			pbeg++;
			
            if (j<C_NEW) {
            	//fprintf(stderr,"\n entra code: S_value %ld, zeronode %ld", S_value,zeroNode);
				//	writes a word
				writeWord(outWriter,words[j].word, words[j].size);
			
			}
			else {

				if (j == C_NEW) {  //C_NEW

					{ //moves until end of ascii word.
						register unsigned long len,c1;

						unsigned char *w;
						codeStart2 = pbeg;

						while (*pbeg !='\0') {
							pbeg++;
						}

                     	j=zeroNode;

						len = pbeg-codeStart2;
						pbeg=codeStart2;

						writeWord(outWriter,pbeg, len);

						getMemoryBlock(_memMgr,( char**)&(words[j].word),len+1);
						
						w=words[j].word;
						for (register int i=0;i<len;i++) {  //copia tambien el '\0'
							*(w++)=*(pbeg++);
						}
						*w=0; //writes the '\0'
						words[j].size=len;
						
					}
					pbeg++;
					zeroNode++;
				}
				else if (j==(C_SWAP))
				{//	fprintf(stderr,"\nA SWAP OCCURS \n");

						//Reading the code of the promoting word 
												
						codeStart = pbeg;
						//decoding next codeword
						K=1;
						if ( (*pbeg) >= S_value ) {
							nj = (*pbeg) - S_value;
							pbeg++;
							K++;
				
							while ((*pbeg) >= S_value) {				
								nj = nj * C_value + ((*pbeg) - S_value);
								pbeg++;
								K++;
							}
				
							nj = nj * S_value + (*pbeg);
							nj += W[S_value][K-2];
				
						}
						else {
							nj = (*pbeg);
						}
						//end decoding
						pbeg++;
						Ktmp=K;
						

						//Reading the code of the word that goes down 

						codeStart2 = pbeg;
						//decoding next codeword
						K=1;
						if ( (*pbeg) >= S_value ) {
							j = (*pbeg) - S_value;
							pbeg++;
							K++;
				
							while ((*pbeg) >= S_value) {				
								j = j * C_value + ((*pbeg) - S_value);
								pbeg++;
								K++;
							}
				
							j = j * S_value + (*pbeg);
							j += W[S_value][K-2];
						}
						else {
							j = (*pbeg);
						}
						//end decoding
						
						pbeg++;
						
						writeWord(outWriter,words[nj].word, words[nj].size);						
						//swap
						{int tmpS;
						tmpW = words[nj].word;
						tmpS = words[nj].size;
						words[nj].word = words[j].word;
						words[nj].size = words[j].size;
						words[j].word = tmpW;
						words[j].size = tmpS;
					    //swap(words[nj].word,words[j].word);
						}
				}// end swap
				
				else { //j==C_SCHANGE
					{unsigned long ss,newC,newPosition;

						//Warns about a change of S
						codeStart = pbeg;
						//decoding next codeword
						K=1;
						if ( (*pbeg) >= S_value ) {
							ss = (*pbeg) - S_value;
							pbeg++;
							K++;
				
							while ((*pbeg) >= S_value) {				
								ss = ss * C_value + ((*pbeg) - S_value);
								pbeg++;
								K++;
							}
				
							ss = ss * S_value + (*pbeg);
							ss += W[S_value][K-2];
						}
						else {
							ss = (*pbeg);
						}						
						//end decoding
						
						newC = ss;
						
						pbeg++;	
				
						codeStart=pbeg;
						
						//Receives code and then swaps word in position "beta == ss" 
						//and in the following position (decoded next)
						
						//decoding next codeword
						K=1;
						if ( (*pbeg) >= S_value ) {
							ss = (*pbeg) - S_value;
							pbeg++;
							K++;
				
							while ((*pbeg) >= S_value) {				
								ss = ss * C_value + ((*pbeg) - S_value);
								pbeg++;
								K++;
							}
				
							ss = ss * S_value + (*pbeg);
							ss += W[S_value][K-2];
						}
						else {
							ss = (*pbeg);
						}						
						//end decoding						
						
						newPosition=ss;					
						pbeg++;	
						
						pbeg++;   //skips the ending '\0'.
						
						//fprintf(stderr,"\n received %ld", newPosition);								
						
						{   if (newC > C_value) S_value= S_value-1;
							int tmpS;
							tmpW = words[newPosition].word;
							tmpS = words[newPosition].size;
							words[newPosition].word = words[S_value].word;
							words[newPosition].size = words[S_value].size;
							words[S_value].word = tmpW;
							words[S_value].size = tmpS;						  
						}
												
						C_value = newC;
						S_value = B_value -C_value;
						
						initializeScapeValues();				
					}
				}
			}/*else != zeronode*/

		}/* inner while*/

		nextbuf=pbeg;
		bufLoad (B, (char*)nextbuf);

	}//while
   }

	//fprintf(stderr, "\n... DECOMPRESSION FINISHED after %d words\n\n");

	bufDestroy(B);
	destroyWriter(outWriter);
	free(words);
	destroyMemoryManager(_memMgr);

} //mainDecompressor



//reads the vocabulary size from the aulixiar file (if it exists)
long readSizeVocabulary(char *filename) {
	char fileNametmp[24];
	int file;
	unsigned long value;
	
	strcpy (fileNametmp,filename);
	strcat(fileNametmp,".voc");	
	
	if ( (file = open (fileNametmp, O_RDONLY)) ==-1) {
		fprintf(stderr,"\nError while opening file: %s\n\tUsing default vocabulary size instead\n",fileNametmp);
		return -1;
	}
	read(file,  &value,  4);
	close (file);
	return (value);
}



/*------------------------------------------------------------------
  Shows a message with info of this version of the code 
  ------------------------------------------------------------------*/
void showMessage() {
	printf("\n*Dynamic Lightweight SC Dense Code v0.9 [dynamic decompressor]");
	printf("\n*CopyRight(c)2006  Nieves R. Brisaboa, Gonzalo Navarro, Antonio Faria and Jos R. Param\n");
	
    printf("\n  #DLSCDC comes with ABSOLUTELY NO WARRANTY; ");
    printf("\n  #This is free software, and you are welcome to redistribute it ");
    printf("\n  #under certain conditions\n\n");
}

/*------------------------------------------------------------------ */
/*
 *  DECOMPRESSOR PROGRAM OF DYNAMIC DLETDC.
 */
/*------------------------------------------------------------------ */

int main(int argc, char* argv[])
{
	char fileName[20];

	long sizeNValue;

	showMessage();

	if (argc < 3) {
		fprintf(stderr,"\n Wrong call to DLSCDC dynamic decompressor\n");
		fprintf(stderr," Use:  %s  <in file>  <out file> <[VOC SIZE]>\n",argv[0]);
		return 0;
	}

	sizeNValue = readSizeVocabulary(argv[1]);
	
	if (argc ==4)
		  sizeNValue = atol(argv[3]);

	if (sizeNValue == -1) {sizeNValue = MAX_LEN_VOCABULARY; }

	fprintf(stderr,"\nVocabulary size set to :%ld",sizeNValue);

	printf("\n SIZE VALUE  %l\n",sizeNValue);

	StartRusageTime();
	mainDecompressor(argv[1], argv[2],sizeNValue);
	//StopRusageTime();
	StopRusageTimeFile("TimesDlscdc.TXT",argv[1]);
	fprintf(stderr,"\nExact Number of words in vocabulary: %ld ",zeroNode);
	fprintf(stderr,"\n\n*Decompression finished.\n");

}
